#
# Conditional build:
%bcond_without	apidocs		# API documentation
%bcond_without	static_libs	# static library
#
Summary:	Nanopb - Protocol Buffers for Embedded Systems
Summary(pl.UTF-8):	Nanopb - Protocol Buffers dla systemów wbudowanych
Name:		nanopb
Version:	0.4.9.1
Release:	2
License:	BSD-like
Group:		Libraries
#Source0Download: https://github.com/nanopb/nanopb/tags
Source0:	https://github.com/nanopb/nanopb/archive/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	a974c454f4cb245b3552f3fea233a3fa
Patch0:		%{name}-config.patch
URL:		https://jpa.kapsi.fi/nanopb/
BuildRequires:	cmake >= 3.14.0
%{?with_apidocs:BuildRequires:	pandoc}
BuildRequires:	protobuf
BuildRequires:	python3 >= 1:3
BuildRequires:	python3-modules >= 1:3
BuildRequires:	rpm-build >= 4.6
BuildRequires:	rpmbuild(macros) >= 1.605
BuildRequires:	sed >= 4.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Nanopb is a small code-size Protocol Buffers implementation in ANSI C.
It is especially suitable for use in microcontrollers, but fits any
memory restricted system.

%description -l pl.UTF-8
Nanopb to mała pod względem rozmiaru kodu implementacja Protocol
Buffers w ANSI C. Jest przydatna szczególnie dla mikrokontrolerów, ale
nadaje się dla każdego systemu o ograniczonej pamięci.

%package devel
Summary:	Header files for Nanopb library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki Nanopb
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	python3
Requires:	python3-modules
Requires:	python3-protobuf

%description devel
Header files for Nanopb library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki Nanopb.

%package static
Summary:	Static Nanopb library
Summary(pl.UTF-8):	Statyczna biblioteka Nanopb
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static Nanopb library.

%description static -l pl.UTF-8
Statyczna biblioteka Nanopb.

%package apidocs
Summary:	API documentation for Nanopb library
Summary(pl.UTF-8):	Dokumentacja API biblioteki Nanopb
Group:		Documentation
BuildArch:	noarch

%description apidocs
API documentation for Nanopb library.

%description apidocs -l pl.UTF-8
Dokumentacja API biblioteki Nanopb.

%prep
%setup -q
%patch -P0 -p1

%{__sed} -i -e '1s,/usr/bin/env python3,%{__python3},' \
	extra/script_wrappers/nanopb_generator.py.in \
	generator/nanopb_generator \
	generator/nanopb_generator.py \
	generator/protoc-gen-nanopb

%build
install -d build
cd build
%cmake .. \
	-DBUILD_SHARED_LIBS=ON \
	%{!?with_static_libs:-DBUILD_STATIC_LIBS=OFF}

%{__make}
cd ..

%if %{with apidocs}
%{__make} -C docs
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

%py3_comp $RPM_BUILD_ROOT%{py3_sitescriptdir}/{nanopb,proto}
%py3_ocomp $RPM_BUILD_ROOT%{py3_sitescriptdir}/{nanopb,proto}

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS.txt CHANGELOG.txt LICENSE.txt README.md
%attr(755,root,root) %{_libdir}/libprotobuf-nanopb.so.0

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/nanopb_generator
%attr(755,root,root) %{_bindir}/nanopb_generator.py
%attr(755,root,root) %{_bindir}/protoc-gen-nanopb
%attr(755,root,root) %{_libdir}/libprotobuf-nanopb.so
%{_includedir}/nanopb
%{py3_sitescriptdir}/nanopb
%{_libdir}/cmake/nanopb

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libprotobuf-nanopb.a
%endif

%if %{with apidocs}
%files apidocs
%defattr(644,root,root,755)
%doc docs/{logo,*.css,*.html,*.svg}
%endif
%changelog
* Mon Mar 10 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/nanopb.git;a=log;h=master

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> bf89e50
- python 3.13 rebuild

* Sun Feb 16 2025 Jakub Bogusz <qboosh@pld-linux.org> f27d10c
- updated to 0.4.9.1

* Fri Oct 18 2024 Jakub Bogusz <qboosh@pld-linux.org> 1f55443
- don't install/package mistaken site-packages/proto file (also conflicting with dir from previous package versions)

* Fri Oct 18 2024 Jan Palus <atler@pld-linux.org> e78cc7d
- up to 0.4.9

* Fri Sep 01 2023 Jan Palus <atler@pld-linux.org> 4883ac9
- R: python3 python3-protobuf in -devel (for nanopb_generator.py)

* Fri Sep 01 2023 Jan Palus <atler@pld-linux.org> 6638c66
- BR: protobuf (for protoc)

* Fri Sep 01 2023 Jan Palus <atler@pld-linux.org> 4261c5e
- BR: python3-modules for %py3_*comp

* Fri Sep 01 2023 Jan Palus <atler@pld-linux.org> c15b3e7
- macros for %cmake

* Fri Jan 13 2023 Jakub Bogusz <qboosh@pld-linux.org> be42bd7
- updated to 0.4.7
- added config patch (enable dynamic allocation)

* Sun Nov 20 2022 Jakub Bogusz <qboosh@pld-linux.org> 91f0980
- updated to 0.4.6.4

* Wed Apr 29 2020 Jakub Bogusz <qboosh@pld-linux.org> a942230
- new

